program Smuggler;
const MaxTowns=24;
type List=^Cell;
     Cell=record
            B:Byte;
            Next:List;
          end;
     Road=record
            D:LongInt;
            Head,Tail:List;
          end;
     MapType=array[1..MaxTowns,1..MaxTowns] of Road;
var A:MapType;
    N,M,P,F:Integer;
    InF,OutF:Text;

procedure AddNewElement(i,j,k:Integer);
begin
  New(A[i,j].Head);
  A[i,j].Head^.Next:=Nil;
  A[i,j].Tail:=A[i,j].Head;
  A[i,j].Head^.B:=i;
  A[i,j].D:=k;
end;

procedure ReadData;
var S:String;
    i,j,k,Aux,Err:Integer;
begin
  ReadLn(InF,N,M,P,F);
  for i:=1 to N do
    for j:=1 to N do
      begin
        A[i,j].Head:=Nil;
        A[i,j].D:=1000000;
      end;
  repeat
    ReadLn(InF,S);
    if S[1]<>'&' then begin
                        Aux:=Pos(' ',S);
                        Val(Copy(S,1,Aux-1),i,Err);
                        Delete(S,1,Aux);
                        Aux:=Pos(' ',S);
                        Val(Copy(S,1,Aux-1),j,Err);
                        Delete(S,1,Aux);
                        Val(S,k,Err);
                        AddNewElement(i,j,k);
                        AddNewElement(j,i,k);
                      end;
  until S[1]='&';
end;

procedure AddToList(var Head,Tail:List;By:Byte);
begin
  if Head=Nil
    then begin
           New(Head);
           Head^.Next:=Nil;
           Head^.B:=By;
           Tail:=Head;
         end
    else begin
           New(Tail^.Next);
           Tail:=Tail^.Next;
           Tail^.B:=By;
           Tail^.Next:=Nil;
         end;
end;

procedure ConcatLists(i,j,k:Integer);
var LAux:List;
begin
  A[i,j].Head:=Nil;
  A[i,j].Tail:=Nil;
  LAux:=A[i,k].Head;
    while LAux<>Nil do
      begin
        AddToList(A[i,j].Head,A[i,j].Tail,LAux^.B);
        LAux:=Laux^.Next;
      end;
  LAux:=A[k,j].Head;
    while LAux<>Nil do
      begin
        AddToList(A[i,j].Head,A[i,j].Tail,LAux^.B);
        LAux:=Laux^.Next;
      end;
end;

procedure Floyd;
var i,j,k:Integer;
begin
  for k:=1 to N do
    for i:=1 to N do
      for j:=1 to N do
        if (i<>j) and (j<>k) and (k<>i)
        then if A[i,k].D+A[k,j].D<A[i,j].D
          then begin
                 A[i,j].D:=A[i,k].D+A[k,j].D;
                 ConcatLists(i,j,k);
                 ConcatLists(j,i,k);
               end;
end;

procedure WriteSolution;
var L:List;
begin
  WriteLn(OutF,'a)');
  WriteLn(OutF,'Traficant:');
  Write(OutF,'    Traseu: ');
  L:=A[M,F].Head;
  while L<>Nil do
    begin
      Write(OutF,L^.B,' ');
      L:=L^.Next;
    end;
  WriteLn(OutF,F);
  WriteLn(OutF,'    Distanta parcursa: ',A[M,F].D);
  WriteLn(OutF,'Echipaj politisti:');
  Write(OutF,'    Traseu: ');
  L:=A[P,F].Head;
  while L<>Nil do
    begin
      Write(OutF,L^.B,' ');
      L:=L^.Next;
    end;
  WriteLn(OutF,F);
  WriteLn(OutF,'    Distanta parcursa: ',A[P,F].D);
  WriteLn(OutF,'b)');
  WriteLn(OutF,'Traficant:');
  Write(OutF,'    Traseu: ');
  L:=A[M,F].Head;
  while L<>Nil do
    begin
      Write(OutF,L^.B,' ');
      L:=L^.Next;
    end;
  WriteLn(OutF,F);
  WriteLn(OutF,'    Distanta parcursa: ',A[M,F].D);
  WriteLn(OutF,'Echipaj politisti:');
  Write(OutF,'    Traseu: ');
  L:=A[P,F].Head;
  while L<>Nil do
    begin
      Write(OutF,L^.B,' ');
      L:=L^.Next;
    end;
  WriteLn(OutF,F);
  WriteLn(OutF,'    Distanta parcursa: ',A[P,F].D);
end;

begin
  Assign(InF,'zona.txt');Reset(InF);
  Assign(OutF,'evad.txt');Rewrite(OutF);
  while not Eof(InF) do
    begin
      ReadData;
      Floyd;
      WriteSolution;
    end;
  Close(InF);
  Close(OutF);
end.