// in theory, O(N*sqrt(N)) / in practice, better than O(N*log(N))
// can be solved in O(N) with next/prev pointers

#include <stdio.h>

#define NMAX 1000100

char out[NMAX];
int i, j, k, N, nleft, npasses;

int main()
{
	N = 1000000;

	nleft = N;
	i = k = 1;
	npasses = 1;

	while (nleft >= k)
	{
		// elimina k elemente

		j = k;
		
		while (j > 0)
		{
			while (out[i])
			{
				i++;
				if (i > N)
					i = 1,
					npasses++;
			}

			out[i] = 1;
			j--;
			nleft--;
		}

		// sari peste k elemente

		j = k;
		
		while (j > 0)
		{
			while (out[i])
			{
				i++;
				if (i > N)
					i = 1,
					npasses++;
			}

			j--;

			i++;
			if (i > N)
				i = 1,
				npasses++;
		}

		k++;
	}

	printf("nleft=%d [k=%d]/npasses=%d\n", nleft, k, npasses);

	return 0;
}